function varargout = DDEs(varargin)
%DDES M-file for DDEs.fig
%      DDES, by itself, creates a new DDES or raises the existing
%      singleton*.
%
%      H = DDES returns the handle to a new DDES or the handle to
%      the existing singleton*.
%
%      DDES('Property','Value',...) creates a new DDES using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to DDEs_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      DDES('CALLBACK') and DDES('CALLBACK',hObject,...) call the
%      local function named CALLBACK in DDES.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help DDEs

% Last Modified by GUIDE v2.5 28-Jun-2008 23:44:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @DDEs_OpeningFcn, ...
                   'gui_OutputFcn',  @DDEs_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before DDEs is made visible.
function DDEs_OpeningFcn(hObject, eventdata, handles, varargin)
setappdata(0,'hndls',handles); % 

% This function has no output args, see OutputFcn.
% hObject handle to figure
% eventdata reserved - to be defined in a future version of MATLAB
% handles structure with handles and user data (see GUIDATA)
% varargin command line arguments to DDEs (see VARARGIN)

% channel = ddeinit('excel','1');   %   Excel
%  1  Excel     - "2005/06/06 17:00 1.2472 1.2475"
channel = ddeinit('MT4','QUOTE');       % 
pair = get(handles.editPair,'UserData');    %   
rc = ddeadv(channel, pair,'newTick(x)','x',[1 1]);  %  
% rc = ddeadv(channel, 'r1c1:r1c1','newTick(x)','x',[1 1]); % 
if (rc==1)                              %   
    disp('Connected');                  %   
end
handles.chann = channel;                %  ID   handles 



% Choose default command line output for DDEs
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes DDEs wait for user response (see UIRESUME)
% uiwait(handles.figure1);




% --- Outputs from this function are returned to the command line.
function varargout = DDEs_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes when user attempts to close figure1.
% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject handle to figure1 (see GCBO)
% eventdata reserved - to be defined in a future version of MATLAB
% handles structure with handles and user data (see GUIDATA)

channel = handles.chann;                    %  ID   handles
pair = get(handles.editPair,'UserData');    %   
ddeunadv(channel,pair);                     %  
% ddeunadv(channel,'r1c1:r1c1');            % 
rc = ddeterm(channel);                      % 
if (rc==1)                                  %   
    disp('Disconnected');                   %   
end

% Hint: delete(hObject) closes the figure
delete(hObject);



% --- Executes during object creation, after setting all properties.
function editPair_CreateFcn(hObject, eventdata, handles)
% hObject handle to editPair (see GCBO)
% eventdata reserved - to be defined in a future version of MATLAB
% handles empty - handles not created until after all CreateFcns called

set(hObject, 'String', 'EURUSD');   %      
set(hObject, 'UserData', 'EURUSD'); %   UserData   - 

% Hint: edit controls usually have a white background on Windows.
% See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editPair_Callback(hObject, eventdata, handles)
% hObject handle to editPair (see GCBO)
% eventdata reserved - to be defined in a future version of MATLAB
% handles structure with handles and user data (see GUIDATA)

oldPair = get(hObject,'UserData');          %   
newPair = get(hObject,'String');            %   
channel = handles.chann;                    %  ID 

disconn = ddeunadv(channel,oldPair);    %  
if (disconn==0)                         %     
    set(hObject,'String',oldPair);      %       
else                                    %   
    conn = ddeadv(channel, newPair,'newTick(x)','x',[1 1]); %   
    if (conn==1)                                            %   
        set(hObject,'UserData',newPair);%    
    else                                %      
        ddeadv(channel, oldPair,'newTick(x)','x',[1 1]);    %  
        set(hObject,'String',oldPair);  %       
    end
end

% Hints: get(hObject,'String') returns contents of editPair as text
% str2double(get(hObject,'String')) returns contents of editPair as a double


% --- Executes on button press in pushSave.
% --- Executes on button press in pushSave.
function pushSave_Callback(hObject, eventdata, handles)
% hObject handle to pushSave (see GCBO)
% eventdata reserved - to be defined in a future version of MATLAB
% handles structure with handles and user data (see GUIDATA)
date = datestr(now,'yyyy-mm-dd');           %   (string)
time = datestr(now,'HH-MM-SS');             %   (string)
name = get(handles.editPair,'UserData');    %   (string)
template = [name '@' date '@' time];        %   
[userName, userPath] = uiputfile([template '.txt']); %      
if userName~=0                              %     
    ticks = getappdata(0,'data');           %    root
    timesStr = datestr(ticks.array(:,1));   %  string-
                                            %   
    bidStr = num2str(ticks.array(:,3));     %  string- BID
    delimStr(1:length(bidStr)) =' ' ; %  "" 
                %  ,      
    matrix=[timesStr delimStr' bidStr];     %   Str   
    dlmwrite([userPath userName], matrix, '');  %    
end

%   =)
